/* 
 * File:   newmain.c
 * Author: kushihashi
 *
 * Created on 2013/08/08, 1:47
 */

#include <stdio.h>
#include <stdlib.h>
/*******************************************************
*	$B%^%$%/%m%m%\%3%s(B2013$BG/%b%G%k%F%9%HMQ%W%m%0%i%`(B		$BF|K\9)6HBg3X(B
*       $B%;%s%5!<(B1$B8D$N$_%b%G%k(B
*	pic16f676
*
*	Motor1	Vref	Rin		Fin
*			RC5		RC4		RC3
*
*	Motor2	Vref	Rin		Fin
*			RC0		RC1		RC2
*
*	$B%;%s%5(BLED$B=PNO(B(0$B=PNO"*H/8w(B)
*	sensor1(U2)	sensor2(U1)	sensor3(U4)	sensor4(U3)
*	  RA1             RA2              RA4              RA5
*
*	$B%;%s%5$+$i$NF~NO?.9f!J(B0:$B9u!&0E$$!"(B1:$BGr!&L@$k$$!K(B
*	RA3
*
*	AD$BJQ492DG=%A%c%s%M%k(B
*	AN0
*
*	$B%b!<%?!<@)8f$K$D$$$F!!(BDMode$B$H$$$&JQ?t$r;HMQ$7$^$9!#(BDMode$B$NCM$K$h$C$F:81&$N%b!<%?$N@)8f$r$7$^$9!#(B
*	DMode = 1 $B@5E>!JA0?J!K(B
*			2 $B1&6J$,$j(B
*			3 $B:86J$,$j(B
*			4 $B6uE>(B
*
*******************************************************/

#include <pic.h>
//#include <delays.h>
#define _XTAL_FREQ 4000000
// PIC16F676 Configuration Bit Settings

#include <xc.h>

// CONFIG
#pragma config FOSC = INTRCIO   // Oscillator Selection bits (INTOSC oscillator: I/O function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (PWRT enabled)
#pragma config MCLRE = OFF      // RA3/MCLR pin function select (RA3/MCLR pin function is digital I/O, MCLR internally tied to VDD)
#pragma config BOREN = OFF      // Brown-out Detect Enable bit (BOD disabled)
#pragma config CP = OFF         // Code Protection bit (Program Memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)


unsigned char cnt0=0;
unsigned char PWM1 = 8;
unsigned char PWM2 = 8;
unsigned char DMode = 1;
int adconv();

#define cnt0max 16


//$B3d$j9~$_=hM}(B
static void interrupt isr(void){
	if(T0IF==1){
		TMR0 = 255;
		cnt0++;
		cnt0 &= (cnt0max - 1);
		//RC0,RC5$B!'(BPWM$B=PNO(B
		if(cnt0>=PWM1 && cnt0 >= PWM2){
			RC0=1;
			RC5=1;
		}
		else if(cnt0 >= PWM1 && cnt0 < PWM2){
			RC0 = 1;
			RC5 = 0;
		}
		else if(cnt0 >= PWM2 && cnt0 < PWM1){
			RC0 = 0;
			RC5 = 1;
		}
		else{
			RC0 = 0;
			RC5 = 0;
		}
	}

	T0IF = 0;
	RAIF = 0;

}
/*
 * 
 */
int main(int argc, char** argv) {
//$BJQ?t@k8@(B
	int ADVcc=0;						//AD$BJQ49MQJQ?t(B
//$BA0=hM}(B
	OSCCAL 		=	0b10000000;			//$B#4(BMH$B#z$NCf1{CM!);H$&(B
	CMCON		= 	0b00000111;			//$B%3%s%Q%l!<%?(BOFF
	TRISA  		=	0b00001001;			//RA0,RA3$BF~NO(B
	TRISC  		=	0b00000000;			//PORTC$BA4$F=PNO(B
	PORTA		=	0b00000000;
	PORTC	 	=	0b00000000;
	OPTION_REG 	=	0b11010110;
	ANSEL		=	0b00000001;
	GIE 		= 	1;				//$B3d$j9~$_5v2D(B
	T0IE 		=	1;				//$B%?%$%^3d9~$_5v2D(B
        RA5             =       0;                              //U3
        RA1             =       1;
        RA2             =       1;
        RA4             =       1;
	while(1){
		switch (DMode){
			case 1: //Motor1$B!'(BForward,	Motor2$B!'(BForward
					RC1=0;
					RC2=1;
					RC3=1;
					RC4=0;
					break;
			case 2: //Motor1$B!'(BBrake ,	Motor2$B!'(BForward
					RC1=0;
					RC2=1;
					RC3=1;
					RC4=1;
					break;
			case 3: //Motor1$B!'(BForward ,	Motor2$B!'(BBrake
					RC1=1;
					RC2=1;
					RC3=1;
					RC4=0;
					break;
			case 4: //Motor1$B!'(BFree ,	Motor2$B!'(BFree
					RC1=0;
					RC2=0;
					RC3=0;
					RC4=0;
					break;
			default:
					RC1=0;
					RC2=0;
					RC3=0;
					RC4=0;
					break;
		}
		if(RA3==1){//$BGr$r8!=P$7$?$H$-(B
                    DMode = 2;
                }
                else{
                    DMode = 3;
                }
	}
    return (EXIT_SUCCESS);
}

//AD$BJQ49MQ4X?t(B
int adconv()
{
	int ADdata1;
	ADCON0 = 0b00000000;			//$B:85M$a(B,$B4p=`EE05(BVdd
	ADCON1 = 0b01010000;
	ADON = 1;				//$BC_EE%9%?!<%H(B
	_delay(20);                             //PWM$BMQ$K%?%$%^!<3d$j9~$_$r;H$C$F$$$k$?$aIT@53N(B
        GO = 1;
	while(1){
		if(GO == 0){
			break;
		}
	}
	ADdata1 = ADRESH;			//AD$BJQ497k2L>e0L(B8bit$B<hF@(B
	return ADdata1;
}